//Proiect BinomialHeap
//------------ Tiberiu Petrica 334CB --------
import java.awt.*;
import java.applet.*;
import java.util.*;
import java.io.*;
import java.lang.*;

class Nod {
	
	private Nod parent;
	private int key;
	private int degree;
	private Nod child;
	private Nod sibling;
	private Color color;
	
	public Nod(){
		parent = null;
		key = 0;
		degree = 0;
		child = null;
		sibling = null;
			
	}

	public Nod (Nod n){
		this.parent = n.getParent();
		this.key = n.getKey();
		this.degree = n.getDegree();
		this.child = n.getChild();
		this.sibling = n.getSibling();
		this.color = n.getColor();
	}
	
	public void setParent (Nod p){
		parent = p;
	}
	
	public void setKey (int k){
		key = k;
	}
	
	public void setDegree (int d){
		degree = d;
	}
	
	public void setChild (Nod n){
		child = n;		
	}
	
	public void setSibling (Nod n){
		sibling = n;
	}
	
	public void setColor(Color c){
		color = c;
	}
	
	public Nod getParent(){
		return parent;
	}
	
	public int getKey(){
		return key;
	}
	
	public int getDegree(){
		return degree;
	}
	
	public Nod getChild(){
		return child;
	}
	
	public Nod getSibling(){
		return sibling;
	}
			
	public Color getColor(){
		return color;
	}		
	public void draw(Graphics g, int x, int y, int i, Color c){
		if (i!=0){	
		g.setColor(color);
		}
		else 
			g.setColor(c);
		g.drawOval(x,y,17,17);//18,18
		g.drawString(Integer.toString(key),x+3,y+13);
	}
	
}




public class BinomialHeap extends Applet{
	
	private Nod head;
	private Button insert, decrease, extractMin, findMin, delete;
	private Button siblingB, childB, parentB,headB;
		
	private TextField text,text1;
	private Label label,label1;
			
	private int x,y;      // pozitia heap
	private int nrNod = 0;
	private Nod walk; //cu asta ma plimb prin heap
	
		
	public void init(){
	
	
		
		
		add(insert = new Button("Insert"));
		add(siblingB = new Button("Sibling"));
		add(childB = new Button("Child"));
		add(parentB = new Button("Parent"));
		add(headB = new Button("Head"));
		add(decrease = new Button("Decrease"));
		add(extractMin = new Button("ExtractMin"));
		add(findMin = new Button("FindMin"));
		add(delete = new Button("Delete"));

	
	  add(text = new TextField());
		add(label = new Label("Key")); 
		add(text1 = new TextField());
		add(label1 = new Label("New key"));
	

		
	}
	
	public void paint(Graphics g){
		
		
	
		label.resize(30,20);
		label.move(10,273);
		
		text.resize(25,20);
		text.move(35,273);
		text.requestFocus();
		text.setText("");
				
		insert.resize(60,20);
		insert.move(10,250);
	
		siblingB.resize(80,20);
		siblingB.move(110,250);
		
		childB.resize(65,20);
		childB.move(80,273);
		
		parentB.resize(65,20);
		parentB.move(155,273);
		
		headB.resize(80,20);
		headB.move(110,296);
		
		label1.resize(50,20);
		label1.move(235,273);
		
		text1.resize(30,20);
		text1.move(290,273);
				
		decrease.resize(100,20);
		decrease.move(235,250);	
		
		extractMin.resize(100,20);
		extractMin.move(355,250);	
	
		findMin.resize(100,20);
		findMin.move(475,250);	
		
		delete.resize(100,20);
		delete.move(595,250);	
		
	
 		g.setColor(Color.red);
		g.drawLine(10,20,670,20);
		
		text.requestFocus();	
		text.setText("");
	
		
		drawBinomialHeap(g,190,20,1,null);
		//validate();			 	
	 	
	}
	
	public void desen(int i,Color c){
	
		Graphics g = getGraphics();
		drawBinomialHeap(g,190,20,i,c);
		repaint();
	}	
	
	public void desen(int x, int y, int i, Color c){
	
		Graphics g = getGraphics();
		drawBinomialHeap(g,x,y,i,c);
		repaint();
	}	
	
	public boolean action(Event e, Object arg){
			if (e.target instanceof Button) {
				if (e.target == insert){
					int k;
					Nod n = new Nod();
					k = Integer.parseInt(text.getText());
					n.setKey(k);
					n.setColor(Color.red);
					if (k>=0 && k<100 && nrNod <= 30){
						binomialHeapInsert(n);
						
					}
					return true;
				}
				else
					if (e.target == siblingB){
						if (walk!=null) {
							walk.setColor(Color.red);
							if (walk.getSibling()!=null)
								walk = walk.getSibling();
							walk.setColor(Color.blue);
							repaint();
						}	
						return true; 	
					}	
					else
						if (e.target == childB){
							if (walk!=null) {
			
								walk.setColor(Color.red);
								if (walk.getChild()!=null)
									walk = walk.getChild();
								walk.setColor(Color.blue);
								repaint();
							}	
							return true; 	
						}	
						else
							if (e.target == parentB){
								if (walk!=null) {
			
									walk.setColor(Color.red);
									if (walk.getParent()!=null)
										walk = walk.getParent();
									walk.setColor(Color.blue);
									repaint();
								}	
								return true; 	
							}	
							else
								if (e.target == headB){
									if (walk!=null) {
			
										walk.setColor(Color.red);
										if (head!=null)
											walk = head;
										walk.setColor(Color.blue);
										repaint();
									}	
									return true; 	
								}	
								else
									if (e.target == decrease){
											
											int k = Integer.parseInt(text1.getText());
											if (k < walk.getKey())
												binomialHeapDecreaseKey (walk,k);
											repaint();
											
										return true; 	
									}	
									else
									if (e.target == extractMin){
																					
											binomialHeapExtractMin();
											walk.setColor(Color.red);
											walk = head;
											walk.setColor(Color.blue);
											repaint();
											
										return true; 	
									}	
									else
									if (e.target == delete){
																					
											binomialHeapDelete(walk);
											walk = head;
											walk.setColor(Color.blue);											
											repaint();
											
										return true; 	
									}	
									else
									if (e.target == findMin){
											
											walk.setColor(Color.red);										
											walk = binomialHeapMinimum();
											walk.setColor(Color.blue);
											repaint();
											
										return true; 	
									}	

		}	
		return false;
	}
			
		
	public void drawTree(Graphics g, Nod h, int x1, int y1, int i,Color c){
		Nod aux = h;
		
		if (aux != null){
			aux.draw(g,x1,y1,i,c);
			if (aux.getChild()!= null){
				
				if(aux.getChild().getDegree() >=3)
					drawTree(g,aux.getChild(),x1-(aux.getChild().getDegree()*25+25),y1+25,i,c);
				else
					drawTree(g,aux.getChild(),x1-(aux.getChild().getDegree()*25),y1+25,i,c);
					
			}	
			
			if (aux.getSibling()!= null && (x1!=x || y1!=y)){
				if(aux.getSibling().getDegree()>=2)
					drawTree(g,aux.getSibling(),x1+50,y1,i,c);
				else
					drawTree(g,aux.getSibling(),x1+25,y1,i,c);
			}
													
		}
		
	}
	
	public void drawBinomialHeap(Graphics g, int x1, int y1,int i, Color c){
			Nod aux = head;
			x=x1;y=y1;
			while (aux!=null){
				drawTree(g,aux,x1,y1,i,c);
				if (aux.getSibling()!=null){
					switch(aux.getSibling().getDegree()){
						case 4: x+=225;
										 x1+=225;
										 break;
						case 3: x+=125;
										 x1+=125;
										 break;
						case 2: x+=75;
										 x1+=75;
										 break;
						case 1: x+=50;
										 x1+=50;
										 break;
						case 0: x+=50;
										 x1+=50;
										 break;				 				 				 
					}
				}
				else {
					x+=25;
					x1+=25;
				}
				aux = aux.getSibling();
				
			}
			
	}

	public BinomialHeap(){
		head = null;
	
	}
	
	public void setHead (Nod n){
		head = n;
	}
	
	public Nod getHead(){
		return head;
	}
	
	
	
	public void binomialLink (Nod y, Nod z){
		
		y.setParent(z);
		y.setSibling(z.getChild());
		z.setChild(y);
		z.setDegree(z.getDegree()+1);
	}
	
	public void binomialHeapMerge (BinomialHeap H1){
		
		Nod temp, temp1, aux;
		if (head!=null){
			if (H1.getHead().getDegree() < head.getDegree()){
				temp = head;
				head = H1.getHead();
				temp1 = head.getSibling();
				aux = head;
			}
			else {
				temp = head.getSibling();
				temp1 = H1.getHead();
				aux = head;
			}
			
			while(temp!=null && temp1!=null){
				if (temp1.getDegree() < temp.getDegree()){
					aux.setSibling(temp1);
					aux = aux.getSibling();
					temp1 = temp1.getSibling(); 
				}
				else {
					aux.setSibling(temp);
					aux = aux.getSibling();
					temp = temp.getSibling();
				}
			}
			
			while(temp!=null){
				aux.setSibling(temp);
				aux = aux.getSibling();
				temp = temp.getSibling();
			}
		
			while(temp1!=null){
				aux.setSibling(temp1);
				aux = aux.getSibling();
				temp1 = temp1.getSibling();
			}
		}
		else 
			head = H1.getHead();
			
				
	} 
	
	
	public void binomialHeapUnion (BinomialHeap H1){
		
		binomialHeapMerge(H1);
		desen(1,null);
		try{
			Thread.sleep(2500);		
		}
		catch(InterruptedException e){
		}

		

		Nod prevx, x, nextx;
		prevx = null;
		x = head;
		nextx = x.getSibling();
		
		while (nextx!=null){
			desen(0,getBackground());
			try{
				Thread.sleep(5);		
			}
			catch(InterruptedException e){
			}
  		
		
			if ((x.getDegree()!= nextx.getDegree()) || (nextx.getSibling()!=null && nextx.getSibling().getDegree() == x.getDegree())){
				prevx = x;
				x = nextx;
			}
			else{
				if (x.getKey()<=nextx.getKey()){
					x.setSibling(nextx.getSibling());
					binomialLink(nextx,x);
				} 
				else {
					if(prevx == null){
						head = nextx;
					}
					else prevx.setSibling(nextx);
					binomialLink(x,nextx);
					x = nextx;
				}
			}
			nextx = x.getSibling();
			desen(1,null);
			try{
				Thread.sleep(2500);		
			}
			catch(InterruptedException e){
			}

		}
		
		
	}
	
	public void binomialHeapInsert (Nod x){
	
		BinomialHeap H1 = new BinomialHeap();
		x.setParent(null);
		x.setChild(null);
		x.setSibling(null);
		x.setDegree(0);
		H1.setHead(new Nod(x));
		if (walk!=null)
				walk.setColor(Color.red);
		desen(0,getBackground());
		binomialHeapUnion(H1);
		walk = head;
		walk.setColor(Color.blue);
		
		nrNod++;
	}

	public Nod binomialHeapMinimum(){
		Nod y = null;
		Nod x = head;
		int min = 100;
		
		while (x!= null){
			if (x.getKey()<min){
				min = x.getKey();
				y = x;
			}
			x = x.getSibling();
		}
	
		return y;
	}
	
	
	
	public Nod binomialHeapExtractMin(){
		
		desen(0,getBackground());
		try{
			Thread.sleep(5);		
		}
		catch(InterruptedException e){
		}
			
		Nod prevx,x,nextx,n,p=null;
		prevx = null;
		x = head;
		nextx = x.getSibling();
		Nod y = null;
		
		int min = 100;
		BinomialHeap H1 = new BinomialHeap();
				
		while (x!= null){
			if (x.getKey()<min){
				min = x.getKey();
				y = x;
				p = prevx;
										
			}
			prevx = x;
			x = x.getSibling();
				
		}
		
		if (p!=null){
			p.setSibling(y.getSibling());
			H1.setHead(y);
			H1.getHead().setSibling(null);
		
		}	
		else{ 
			
			
			if(head.getSibling()!=null){
				head = head.getSibling();
				H1.setHead(y);
				H1.getHead().setSibling(null);
			
				
			}
			else{ 
				head = null;
				H1.setHead(y);
			}	
		}	
		
		
		Nod temp = H1.getHead();
		Nod prevz,z,nextz;
		prevz = null;
		z = temp.getChild();
		nextz = z.getSibling();
		z.setParent(null);
		
		if (z!=null){
			while (nextz!=null){
				z.setSibling(prevz);
				z.setParent(null);
				prevz = z;
				z = nextz;
				nextz = nextz.getSibling();
			}
			z.setSibling(prevz);
			z.setParent(null);

			H1.setHead(z);
		
		}
		
		else{
			H1.setHead(null);
		}

		
		desen(1,null);
		Graphics g = getGraphics();
		
		H1.drawBinomialHeap(g,490,20,1,null);
		repaint();
		try{
			Thread.sleep(2500);		
		}
		catch(InterruptedException e){
		}
		desen(0,getBackground());
		H1.drawBinomialHeap(g,490,20,0,getBackground());
		repaint();
		try{
			Thread.sleep(5);		
		}
		catch(InterruptedException e){
		}
						
		binomialHeapUnion(H1);	
		return y;
			
	}
	
	
	
	public void binomialHeapDecreaseKey (Nod x, int k){
		
		Nod y,z;
		int aux;
		Color aux1;	
		desen(0,getBackground());
		try{
				Thread.sleep(5);		
			}
			catch(InterruptedException e){
			}
		x.setKey(k);
		y = x;
		z = y.getParent();

		desen(1,null);
		repaint();
		try{
				Thread.sleep(2500);		
			}
			catch(InterruptedException e){
			}
		
		while (z != null && y.getKey() < z.getKey()){
			desen(0,getBackground());
			try{
				Thread.sleep(5);		
			}
			catch(InterruptedException e){
			}
			aux = y.getKey();
			aux1= y.getColor();
			y.setKey(z.getKey());
			y.setColor(z.getColor());
			z.setKey(aux);
			z.setColor(aux1);
			y = z;
			walk = z;
			z = y.getParent();
			desen(1,null);
			try{
				Thread.sleep(2500);		
			}
			catch(InterruptedException e){
			}
		
		}
		   	
	}
	
	public void binomialHeapDelete (Nod x){
		binomialHeapDecreaseKey (x,-1);
		binomialHeapExtractMin();
	} 
	
	
}